/* Generated by CIL v. 1.5.1 */
/* print_CIL_Input is false */

#line 157 "include/linux/types.h"
typedef unsigned int gfp_t;
#line 32 "include/linux/mm_types.h"
struct kmem_cache;
#line 13 "include/linux/irqhandler.h"
enum irqreturn {
    IRQ_NONE = 0,
    IRQ_HANDLED = 1,
    IRQ_WAKE_THREAD = 2
} ;
#line 16 "include/linux/irqreturn.h"
typedef enum irqreturn irqreturn_t;
#line 29 "include/linux/types.h"
typedef _Bool bool;
#line 361 "./arch/x86/include/asm/pgtable_types.h"
struct page;
#line 142 "include/linux/printk.h"
extern int printk(char const   *  , ...) ;
#line 26 "/home/cluser/ldv/inst/kernel-rules/verifier/rcv.h"
extern void *ldv_undef_ptr(void) ;
#line 293 "include/linux/slab.h"
void *ldv_kmem_cache_alloc_20(struct kmem_cache *ldv_func_arg1 , gfp_t flags ) ;
#line 18 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--43_2a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/11708/dscv_tempdir/dscv/ri/43_2a/drivers/misc/dummy-irq.o.c.prepared"
void ldv_check_alloc_flags(gfp_t flags ) ;
#line 127 "include/linux/interrupt.h"
extern int request_threaded_irq(unsigned int  , irqreturn_t (*)(int  , void * ) ,
                                irqreturn_t (*)(int  , void * ) , unsigned long  ,
                                char const   * , void * ) ;
#line 132 "include/linux/interrupt.h"
__inline static int request_irq(unsigned int irq___0 , irqreturn_t (*handler)(int  ,
                                                                              void * ) ,
                                unsigned long flags , char const   *name , void *dev ) 
{ 
  int tmp ;

  {
#line 135
  tmp = request_threaded_irq(irq___0, handler, (irqreturn_t (*)(int  , void * ))0,
                             flags, name, dev);
#line 135
  return (tmp);
}
}
#line 146
extern void free_irq(unsigned int  , void * ) ;
#line 23 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--43_2a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/11708/dscv_tempdir/dscv/ri/43_2a/drivers/misc/dummy-irq.c"
static int irq  =    -1;
#line 25 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--43_2a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/11708/dscv_tempdir/dscv/ri/43_2a/drivers/misc/dummy-irq.c"
static irqreturn_t dummy_interrupt(int irq___0 , void *dev_id ) 
{ 
  int count ;

  {
#line 27
  count = 0;
#line 29
  if (count == 0) {
#line 30
    printk("\016dummy-irq: interrupt occurred on IRQ %d\n", irq___0);
#line 32
    count = count + 1;
  } else {

  }
#line 35
  return (0);
}
}
#line 38 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--43_2a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/11708/dscv_tempdir/dscv/ri/43_2a/drivers/misc/dummy-irq.c"
static int dummy_irq_init(void) 
{ 
  int tmp ;

  {
#line 40
  if (irq < 0) {
#line 41
    printk("\vdummy-irq: no IRQ given.  Use irq=N\n");
#line 42
    return (-5);
  } else {

  }
#line 44
  tmp = request_irq((unsigned int )irq, & dummy_interrupt, 128UL, "dummy_irq", (void *)(& irq));
#line 44
  if (tmp != 0) {
#line 45
    printk("\vdummy-irq: cannot register IRQ %d\n", irq);
#line 46
    return (-5);
  } else {

  }
#line 48
  printk("\016dummy-irq: registered for IRQ %d\n", irq);
#line 49
  return (0);
}
}
#line 52 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--43_2a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/11708/dscv_tempdir/dscv/ri/43_2a/drivers/misc/dummy-irq.c"
static void dummy_irq_exit(void) 
{ 


  {
#line 54
  printk("\016dummy-irq unloaded\n");
#line 55
  free_irq((unsigned int )irq, (void *)(& irq));
#line 56
  return;
}
}
#line 83
extern void ldv_check_final_state(void) ;
#line 92
extern void ldv_initialize(void) ;
#line 95
extern void ldv_handler_precall(void) ;
#line 98
extern int nondet_int(void) ;
#line 101 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--43_2a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/11708/dscv_tempdir/dscv/ri/43_2a/drivers/misc/dummy-irq.c"
int LDV_IN_INTERRUPT  ;
#line 104 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--43_2a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/11708/dscv_tempdir/dscv/ri/43_2a/drivers/misc/dummy-irq.c"
void main(void) 
{ 
  int var_dummy_interrupt_0_p0 ;
  void *var_dummy_interrupt_0_p1 ;
  int tmp ;
  int tmp___0 ;
  int tmp___1 ;

  {
#line 124
  LDV_IN_INTERRUPT = 1;
#line 133
  ldv_initialize();
#line 139
  ldv_handler_precall();
#line 140
  tmp = dummy_irq_init();
#line 140
  if (tmp != 0) {
#line 141
    goto ldv_final;
  } else {

  }
#line 145
  goto ldv_21665;
  ldv_21664: 
#line 148
  tmp___0 = nondet_int();
#line 148
  switch (tmp___0) {
  case 0: 
#line 153
  LDV_IN_INTERRUPT = 2;
#line 158
  ldv_handler_precall();
#line 159
  dummy_interrupt(var_dummy_interrupt_0_p0, var_dummy_interrupt_0_p1);
#line 160
  LDV_IN_INTERRUPT = 1;
#line 166
  goto ldv_21662;
  default: ;
#line 167
  goto ldv_21662;
  }
  ldv_21662: ;
  ldv_21665: 
#line 145
  tmp___1 = nondet_int();
#line 145
  if (tmp___1 != 0) {
#line 147
    goto ldv_21664;
  } else {

  }

#line 179
  ldv_handler_precall();
#line 180
  dummy_irq_exit();
  ldv_final: 
#line 183
  ldv_check_final_state();
#line 186
  return;
}
}
#line 171 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--43_2a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/11708/dscv_tempdir/dscv/ri/43_2a/drivers/misc/dummy-irq.o.c.prepared"
void *ldv_kmem_cache_alloc_20(struct kmem_cache *ldv_func_arg1 , gfp_t flags ) 
{ 
  void *tmp ;

  {
#line 174
  ldv_check_alloc_flags(flags);
#line 175
  tmp = ldv_undef_ptr();
#line 175
  return (tmp);
}
}
#line 10 "/home/cluser/ldv/inst/kernel-rules/verifier/rcv.h"
__inline static void ldv_error(void) 
{ 


  {
  ERROR: ;
#line 12
  goto ERROR;
}
}
#line 25
extern int ldv_undef_int(void) ;
#line 7 "/home/cluser/ldv/inst/kernel-rules/kernel-model/ERR.inc"
bool ldv_is_err(void const   *ptr ) 
{ 


  {
#line 10
  return ((unsigned long )ptr > 2012UL);
}
}
#line 14 "/home/cluser/ldv/inst/kernel-rules/kernel-model/ERR.inc"
void *ldv_err_ptr(long error ) 
{ 


  {
#line 17
  return ((void *)(2012L - error));
}
}
#line 21 "/home/cluser/ldv/inst/kernel-rules/kernel-model/ERR.inc"
long ldv_ptr_err(void const   *ptr ) 
{ 


  {
#line 24
  return ((long )(2012UL - (unsigned long )ptr));
}
}
#line 28 "/home/cluser/ldv/inst/kernel-rules/kernel-model/ERR.inc"
bool ldv_is_err_or_null(void const   *ptr ) 
{ 
  bool tmp ;
  int tmp___0 ;

  {
#line 31
  if ((unsigned long )ptr == (unsigned long )((void const   *)0)) {
#line 31
    tmp___0 = 1;
  } else {
#line 31
    tmp = ldv_is_err(ptr);
#line 31
    if ((int )tmp) {
#line 31
      tmp___0 = 1;
    } else {
#line 31
      tmp___0 = 0;
    }
  }
#line 31
  return ((bool )tmp___0);
}
}
#line 20 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--43_2a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/11708/dscv_tempdir/rule-instrumentor/43_2a/common-model/ldv_common_model.c"
int ldv_spin  =    0;
#line 24 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--43_2a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/11708/dscv_tempdir/rule-instrumentor/43_2a/common-model/ldv_common_model.c"
void ldv_check_alloc_flags(gfp_t flags ) 
{ 


  {
#line 27
  if (ldv_spin != 0 && (flags & 16U) != 0U) {
#line 27
    ldv_error();
  } else {

  }
#line 31
  return;
}
}
#line 30
extern struct page *ldv_some_page(void) ;
#line 33 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--43_2a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/11708/dscv_tempdir/rule-instrumentor/43_2a/common-model/ldv_common_model.c"
struct page *ldv_check_alloc_flags_and_return_some_page(gfp_t flags ) 
{ 
  struct page *tmp ;

  {
#line 36
  if (ldv_spin != 0 && (flags & 16U) != 0U) {
#line 36
    ldv_error();
  } else {

  }
#line 38
  tmp = ldv_some_page();
#line 38
  return (tmp);
}
}
#line 42 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--43_2a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/11708/dscv_tempdir/rule-instrumentor/43_2a/common-model/ldv_common_model.c"
void ldv_check_alloc_nonatomic(void) 
{ 


  {
#line 45
  if (ldv_spin != 0) {
#line 45
    ldv_error();
  } else {

  }
#line 49
  return;
}
}
#line 49 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--43_2a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/11708/dscv_tempdir/rule-instrumentor/43_2a/common-model/ldv_common_model.c"
void ldv_spin_lock(void) 
{ 


  {
#line 52
  ldv_spin = 1;
#line 53
  return;
}
}
#line 56 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--43_2a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/11708/dscv_tempdir/rule-instrumentor/43_2a/common-model/ldv_common_model.c"
void ldv_spin_unlock(void) 
{ 


  {
#line 59
  ldv_spin = 0;
#line 60
  return;
}
}
#line 63 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--43_2a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/11708/dscv_tempdir/rule-instrumentor/43_2a/common-model/ldv_common_model.c"
int ldv_spin_trylock(void) 
{ 
  int is_lock ;

  {
#line 68
  is_lock = ldv_undef_int();
#line 70
  if (is_lock != 0) {
#line 73
    return (0);
  } else {
#line 78
    ldv_spin = 1;
#line 80
    return (1);
  }
}
}
